import { Request, Response, NextFunction } from 'express';
import { AppError } from '../utils/AppError';

export function globalErrorHandler(err: any, req: Request, res: Response, next: NextFunction) {
    const errorResponse: { message: string } = {
        message: 'An unexpected error occurred!'
    };

    console.error('Error from Global Error Handler:', err);

    if (err instanceof AppError) {
        // In App Error it is safe to send err.message otherwise send generic error message
        let message = err.message;

        errorResponse.message = message;
        res.status(err.statusCode).json(errorResponse);
        return;
    }

    res.status(500).json(errorResponse);
    return;
}
