import mongoose, { Schema, Document } from 'mongoose';

enum UserRole {
    SUPER_ADMIN = 'SUPER_ADMIN',
    USER = 'USER',
  }
  

const UserSchema = new Schema({
    name: { type: String, required: true },
    email: { type: String, required: true, unique: true },
    phoneNumberId: { type: String, required: true, unique: true },
    role: { type: String, enum: [UserRole.SUPER_ADMIN, UserRole.USER], required: true },
    isActive: { type: Boolean, default: true },
    password: { type: String, required: true },
  }, {
    timestamps: { createdAt: 'created_at', updatedAt: 'updated_at' }, // Automatically handle timestamps
    versionKey: false, // Disable the __v field used by default in Mongoose
    strict: false
  });
  
  // Create the User model
export const User = mongoose.model('User', UserSchema);