import { User } from '../models/UserModel';
import { AppError } from '../utils/AppError';


export class UserRepository {
    async getUserWithPhoneNumberId(phoneNumberId: string): Promise<any| null> {
        try {
            let user = await User.findOne({
                phoneNumberId: phoneNumberId
            })
            return user;
        } catch (err) {
            throw new AppError(500, 'ServerError', 'Something went wrong', err);
        }
    }

    async getUserWithEmail(email: string): Promise<any| null> {
        try {
            let user = await User.findOne({
                email
            })
            return user;
        } catch (err) {
            throw new AppError(500, 'ServerError', 'Something went wrong', err);
        }
    }

    async createUser(userData: any): Promise<any> {
        try {
            let user = await User.create(userData);
            return user;
        } catch (err) {
            throw new AppError(500, 'ServerError', 'Something went wrong', err);
        }
    }
}

export default UserRepository;
