import express from 'express';
import { requireAuth, restrictTo, vapiWebhookAuth } from '../../middlewares/AuthMiddleware';
import CallController from '../../controllers/CallController';
import fs from 'fs';
import path from 'path';
import { error } from 'console';
import { User } from '../../models/UserModel';
import UserController from '../../controllers/UserController';

const router = express.Router();
const callContoller = new CallController();
const userController = new UserController();

import nodemailer from 'nodemailer';

router.get('/call/sync-with-vapi', requireAuth, callContoller.syncDataWithVapi)
router.get('/call', requireAuth, callContoller.getCalls)
router.get('/call/:callId', requireAuth, callContoller.getCallWithCallId)
router.post('/webhook/call', vapiWebhookAuth, callContoller.callWebhookHandler)

router.post('/user/login', userController.login)
router.post('/user/register', userController.register)


// router.get('/user', async (req, res) => {

//     const data = await User.find({})
//     console.log('data', data)

//     res.status(200).json({ message: 'Hello from the API!' });
// })

// router.post('/receive-event', async (req: Request, res: Response) => {
//     try {
//         // Get the event type from the request body
//         const { message } = req.body;

//         // Check if the message exists and contains the event type
//         if (!message || !message.type) {
//             return res.status(400).json({ message: 'Invalid event data' });
//         }

//         // Get the call ID and the event type
//         const { call, type } = message;

//         if (!call || !call.call_id) {
//             return res.status(400).json({ message: 'Call ID is missing in the event' });
//         }

//         const callId = call.call_id;
        
//         // Create the directory to store the files if it doesn't exist
//         const directory = path.join(__dirname, 'events');
//         if (!fs.existsSync(directory)) {
//             fs.mkdirSync(directory);
//         }

//         // Define the file path using the call ID as a prefix
//         const filePath = path.join(directory, `${callId}_event.json`);

//         // Check the event type and handle accordingly
//         if (type === 'status-update' || type === 'end-of-call-report') {
//             // Append the event data to a file
//             fs.writeFileSync(filePath, JSON.stringify(req.body, null, 2), 'utf8');

//             // Return success response
//             return res.status(200).json({ message: 'Event received and saved' });
//         } else {
//             return res.status(200).json({ message: 'Event type not processed' });
//         }
//     } catch (err) {
//         console.error('Error processing event:', err);
//         return res.status(500).json({ message: 'Something went wrong' });
//     }
// });
export default router;