import nodemailer from 'nodemailer'

export class CommunicationService {

    async sendEmail(subject: string, to: string, htmlContent: string) {
        try {
            const transporter = nodemailer.createTransport({
                host: process.env.SMTP_HOST,
                port: 465, // You can also use 465 for SSL encryption
                secure: true, // Set to true for port 465 (SSL)
                auth: {
                    user: process.env.SMTP_USERNAME, // This is the default SMTP username for SendGrid
                    pass: process.env.SENDGRID_API_KEY, // Your SMTP password (the API key)
                },
                tls: {
                    rejectUnauthorized: false, // Optional: Ensures the connection isn't rejected if using self-signed certs
                },
            });
    
            const mailOptions = {
                from: `"Ai Voice Agent" ${process.env.EMAIL_FROM}`, // Sender address
                to, // Receiver address
                subject, // Subject line
                html: htmlContent
            };
    
            const info = await transporter.sendMail(mailOptions);
            console.log('Email sent: ' + info.response);
        } catch (err) {
            console.log(err)
        }
    }
}

export default CommunicationService;
